/*
  LISTDEMO.C 
    A demonstration program which allows the user, through a dialog box,
    to append, insert, and delete strings from a listbox.
*/

#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include "window.h"

#define ID_MENUBAR    10
#define ID_NOTEPAD    12
#define ID_ABOUT      98
#define ID_COMBOBOX   97 
#define ID_EXIT       99

#define ID_LISTDEMO   200
#define ID_TIMEDEMO   201
#define ID_MOUSEDEMO  202
#define ID_MENUDEMO   203
#define ID_FILEDEMO   204
#define ID_EDITDEMO   205
#define ID_EXECDEMO   206

#define ID_DROPDOWN   210
#define ID_DROPDOWNLIST 211
#define ID_SIMPLE     212

#define ID_STRING     100
#define ID_POS        101
#define ID_FRAME      102
#define ID_APPEND     103
#define ID_INSERT     104
#define ID_DELETE     105
#define ID_LISTBOX    106

#define ID_STOP       100
#define ID_START      101
#define ID_INTERVAL   105

#define ID_WORD50     300
#define ID_WRITE      301
#define ID_EXCEL      302
#define ID_124        303
#define ID_C52        304
#define ID_QUICKC     305
#define ID_QUICKBASIC 306
#define ID_PASCAL     307

#define ID_NEW    200
#define ID_OPEN   201
#define ID_SAVE   202
#define ID_SAVEAS 203
#define ID_HELP   205

#define ID_COPY   210
#define ID_CUT    211
#define ID_PASTE  212
#define ID_CLEAR  213

#define ID_GETLEN    220
#define ID_GETLINES  221
#define ID_GETHANDLE 222



typedef struct dlgTemplate
{
  char  *szClass;
  char  *szTitle;
  DWORD dwStyle;
  int   x, y, width, height;
  WORD  idCtrl;
} DTEMPLATE;
extern HWND pascal DialogCreateIndirect();
DTEMPLATE ListboxDialogTemplate[] =
{
  { "Edit",        "Enter string", WIN_HAS_BORDER | WS_GROUP | WS_TABSTOP, 12,5, 26,3, ID_STRING },
  { "Edit",        "Position",     WIN_HAS_BORDER | WS_GROUP | WS_TABSTOP, 12,10,11,3, ID_POS    },
  { "Frame",       "Operation",    WS_GROUP,       25,10,15,9, ID_POS    },
  { "RadioButton", "Append",       WS_GROUP | WS_TABSTOP,     27,12, 0,0, ID_APPEND },
  { "RadioButton", "Insert",       0x0000,         27,14, 0,0, ID_INSERT },
  { "RadioButton", "Delete",       0x0000,         27,16, 0,0, ID_DELETE },
  { "Listbox",     "Strings",      WS_GROUP | LBS_STANDARD | WS_TABSTOP,   42, 5,16,11,ID_LISTBOX},
  { "PushButton",  "~OK",          WS_GROUP | BS_DEFAULT   | WS_TABSTOP,   42,17, 8, 3,IDOK      },
  { "PushButton",  "~CANCEL",      WS_GROUP | WS_TABSTOP,     53,17, 8, 3,IDCANCEL  },
};

DTEMPLATE IntervalDialogTemplate[] =
{
  { "Text",        "Interval:",    0x0000,         27,10, 9, 1, 0        },
  { "Edit",        NULL,           WS_BORDER | WS_TABSTOP | WS_GROUP, 38,10, 6, 1,ID_INTERVAL},
  { "PushButton",  "~OK",          BS_DEFAULT | WS_TABSTOP | WS_GROUP,30,12, 4, 1,IDOK      },
  { "PushButton",  "~CANCEL",      WS_TABSTOP | WS_GROUP,     39,12, 8, 1,IDCANCEL  },
};


long (pascal *OldMainWinProc)();
extern long pascal MainWndProc();
HWND hMain;
HWND hMsgWnd;
HWND hMouseWnd = NULLHWND;
HWND hCombo = NULLHWND;

main(argc, argv)
  int  argc;
  char **argv;
{
  MSG  event;
  HWND   hMenu, hPop;
  HWND   hWndTime;
  WORD   hRes;

  /*
    Initialize the window system - this *must* be done once in every appl
  */
  WinInit();
  WinUseSysColors(NULLHWND, TRUE);
  /*
    Create the main window and set the main window procedure
  */
  hMain = CreateWindow("Normal",       /* class */
                       "MEWEL Demos",  /* title */
                       WS_BORDER  |    /* dwStyle */ 
                       WS_SYSMENU | WS_CAPTION | WS_VSCROLL | WS_HSCROLL,
                       0,0, 80,25,     /* x,y,width,height */
                       SYSTEM_COLOR,   /* attr */
                       0,              /* id */
                       NULLHWND,       /* hParent */
                       NULLHWND,       /* hMenu */
                       0,              /* hInst */
                       0L);            /* lpParam */
  OldMainWinProc = WinSetWinProc(hMain, MainWndProc);
  SetScrollRange(hMain, SB_VERT, 1, 100, FALSE);
  SetScrollRange(hMain, SB_HORZ, 1, 255, FALSE);

  /*
    Create a child window to display the output messages.
  */
  hMsgWnd = CreateWindow("Normal",       /* class */
                         NULL,           /* title */
                         0L,             /* dwStyle */
                         1, 23, 65, 1,   /* x,y,width,height */
                         0x31,           /* attr */
                         1,              /* id */
                         hMain,          /* hParent */
                         NULLHWND,       /* hMenu */
                         0,              /* hInst */
                         0L);            /* lpParam */

  hWndTime = CreateWindow("Normal",    /* class */
                       "Backgrnd",     /* title */
                       WS_BORDER,      /* dwStyle */
                       69,20,11,3,     /* x,y,width,height */
                       SYSTEM_COLOR,   /* attr */
                       1,              /* id */
                       hMain,          /* hParent */
                       NULLHWND,       /* hMenu */
                       0,              /* hInst */
                       0L);            /* lpParam */

  /*
    Create the menu bar and the single item - the DEMO START choice
  */
#if 1
  if ((hRes = OpenResourceFile("mewldemo")) == 0)
  {
    MessageBox("Can't find the", "resource file", "MEWLDEMO.RES", "Fatal Error", MB_OK);
    exit(1);
  }
  hMenu = LoadMenu(hRes, ID_MENUBAR, hMain);
  CloseResourceFile(hRes);
#else
  hMenu = CreateMenu(hMain);
  hPop = CreateMenu(hMenu);
  ChangeMenu(hPop,  0, "E~xit",  ID_EXIT,   MF_APPEND);
  ChangeMenu(hMenu, 0, "~File",  hPop,      MF_POPUP | MF_APPEND);

  hPop = CreateMenu(hMenu);
  ChangeMenu(hPop,  0, "~Listbox",        ID_LISTDEMO,   MF_APPEND | MF_SHADOW);
  ChangeMenu(hPop,  0, "~Timers",         ID_TIMEDEMO,   MF_APPEND | MF_SHADOW);
  ChangeMenu(hPop,  0, "~Mouse",          ID_MOUSEDEMO,  MF_APPEND | MF_SHADOW);
  ChangeMenu(hMenu, 0, "~Demo",           hPop,          MF_POPUP  | MF_APPEND);

  hPop = CreateMenu(hMenu);
  ChangeMenu(hPop,  0, "~About", ID_ABOUT,  MF_APPEND);
  ChangeMenu(hMenu, 0, "~Help",  hPop,      MF_POPUP | MF_APPEND | MF_HELP);
#endif

  SetMenu(hMain, hMenu);

  /*
    Show the window
  */
  ShowWindow(hMain, TRUE);
  SetFocus(hMain);


  /*
    Main message loop
  */
  for (;;)
  {
    /*
      This is how you can do background processing
    */
    while (!PeekMessage(&event))
    {
      int h, m, s;
      char szTime[16];
      DosGetTime(&h, &m, &s);
      sprintf(szTime, "%02d:%02d:%02d", h, m, s);
      WinPuts(hWndTime, 0, 0, szTime, WinGetAttr(hWndTime));
    }
    if (GetMessage(&event) == WM_QUIT)
      break;
    TranslateAccelerator(&event);
    DispatchMessage(&event);
  }
}

/*
  MainWndProc - window procedure for the main window
*/
long pascal MainWndProc(hWnd, message, wParam, lParam)
  HWND hWnd;
  WORD message;
  WORD wParam;
  DWORD lParam;
{
  char buf[80];


  switch (message)
  {
    case WM_COMMAND    :
      if (hMouseWnd)
      {
        DestroyWindow(hMouseWnd);
        hMouseWnd = NULLHWND;
      }
      if (hCombo)
      {
        /*
          Don't shutdown the combobox due to a notification mesage
        */
        if (LOWORD(lParam) != hCombo)
        {
          DestroyWindow(hCombo);
          hCombo = NULLHWND;
        }
      }

      /*
        See if the user chose a demo from the DEMO menubar item
      */
      switch (wParam)
      {
        case ID_LISTDEMO :
          ListboxDemo();
          break;

        case ID_TIMEDEMO :
          TimerDemo();
          break;

        case ID_MOUSEDEMO:
          MouseDemo();
          break;

        case ID_MENUDEMO:
          DoFloatingPopup();
          break;

        case ID_FILEDEMO :
          if (DlgOpenFile(NULLHWND, "*.*", buf))
            MessageBox("You chose", buf, NULL, "Files Demo", MB_OK);
          break;

        case ID_EDITDEMO :
          NotePad();
          break;

        case ID_EXECDEMO :
          DOSEscape();
          break;

        case ID_EXIT     :
          PostQuitMessage(0);
          break;

        case ID_DROPDOWN :
          ComboDemo(CBS_DROPDOWN);
          break;
        case ID_DROPDOWNLIST :
          ComboDemo(CBS_DROPDOWNLIST);
          break;
        case ID_SIMPLE   :
          ComboDemo(CBS_SIMPLE);
          break;

        case ID_COMBOBOX :
          if (HIWORD(lParam) == CBN_DBLCLK)
          {
            int  iSel;
            char buf[32];

            if ((iSel = SendMessage(hCombo, CB_GETCURSEL, 0, 0L)) != CB_ERR)
            {
             /*
               SendMessage(hCombo, CB_GETLBTEXT, iSel, (DWORD) (LPSTR) buf);
               for (iSel = 0;  szColors[iSel] && strcmp(szColors[iSel]);  iSel++)
                 ;
               if (szColors[iSel])
             */
              WinSetAttr(hCombo, iSel, TRUE);
            }
          }
          break;

        case ID_WORD50 :
          MessageBox("You chose", "Word 5.0", NULL, "WM_COMMAND", MB_OK);
          break;
        case ID_WRITE :
          MessageBox("You chose", "WRITE", NULL, "WM_COMMAND", MB_OK);
          break;
        case ID_EXCEL :
          MessageBox("You chose", "EXCEL", NULL, "WM_COMMAND", MB_OK);
          break;
        case ID_124   :
          MessageBox("You chose", "1+2=4", NULL, "WM_COMMAND", MB_OK);
          break;
        case ID_C52   :
          MessageBox("You chose", "C 5.2", NULL, "WM_COMMAND", MB_OK);
          break;
        case ID_QUICKC :
          MessageBox("You chose", "QUICK C", NULL, "WM_COMMAND", MB_OK);
          break;
        case ID_QUICKBASIC :
          MessageBox("You chose", "QUICK BASIC", NULL, "WM_COMMAND", MB_OK);
          break;
        case ID_PASCAL  :
          MessageBox("You chose", "PASCAL", NULL, "WM_COMMAND", MB_OK);
          break;

        case ID_ABOUT   :
          MessageBox("MEWEL Window System", "Magma Systems", 
                     "(201) 912-0192", "About MEWEL", MB_OK | MB_ICONASTERISK);
          break;
      }
      break;

    case WM_SYSCOMMAND :
      switch (wParam)
      {
        case SC_CLOSE :
          PostQuitMessage(0);
          break;
      }
      break;

    case WM_MOUSEMOVE  :
      if (hMouseWnd)
      {
        POINT pt;
        pt = MAKEPOINT(lParam);
        sprintf(buf, "ROW [%2d]  COL [%2d]", pt.y, pt.x);
        WinPutsCenter(hMouseWnd, 0, buf, 0x31);
        break;
      }
      else
        return DefWinProc(hWnd, message, wParam, lParam);

    case WM_CHAR       :
      if (wParam == VK_CTRL_BREAK)
        MessageBox("You hit the", "CTRL+BREAK key", NULL, "Warning", MB_OK);
      break;

    case WM_VSCROLL :
    case WM_HSCROLL :
      PrintScrollbarValues(message, wParam, lParam);
      break;

    case WM_QUIT       :
      exit(0);

    default :
      /* Call the default window procedure for the main window */
      return DefWinProc(hWnd, message, wParam, lParam);
  }

  return FALSE;
}


ListboxDemo()
{
  HDLG   hDlg;
  extern int pascal ListboxDialogProc();

  hDlg = DialogCreateIndirect(hMain,
                              3,10,20,70,
                              "Listbox Dialog",
                              0x31,0L,ListboxDialogProc,
                              ListboxDialogTemplate,
                              sizeof(ListboxDialogTemplate) / sizeof(DTEMPLATE));

  WinSetFlags(hDlg, WS_SYSMENU | WS_CAPTION | WS_MOVEBOX | WS_SIZEBOX);
  WinCreateSysMenu(hDlg);

  return (hDlg) ? DialogBox(hDlg) : FALSE;
}


int pascal ListboxDialogProc(hDlg, message, wParam, lParam)
  HWND hDlg;
  WORD message;
  WORD wParam;
  DWORD lParam;
{
  char szString[80];
  char szPos[30];
  int  iPos;
  int  operation;
  int  iSel;
  static char szItemText[80];
  static int  nMovedItem = - 1;

  switch (message)
  {
    case WM_INITDIALOG :
      SendDlgItemMessage(hDlg, ID_STRING, EM_SETSEL, 0, (DWORD) 0x7FFF);
      SendDlgItemMessage(hDlg, ID_POS,    EM_SETSEL, 0, (DWORD) 0x7FFF);
      return TRUE;

    case WM_CHAR :
      if (wParam == VK_ALT_M && GetDlgItem(hDlg, ID_LISTBOX) == GetFocus())
      {
        if (nMovedItem < 0)
        {
          nMovedItem = SendDlgItemMessage(hDlg,ID_LISTBOX,LB_GETCURSEL,0,0L);
          SendDlgItemMessage(hDlg, ID_LISTBOX, LB_GETTEXT,
                             nMovedItem, (DWORD) (char far *) szItemText);
        }
        else
          nMovedItem = -1;
        return TRUE;
      }
      break;

    case WM_COMMAND    :
      switch (wParam)
      {
      	case IDOK      :
          /*
            The user pressed the OK button. We want to get the string
            that is to be inserted as well as the position.
          */
          GetDialogText(hDlg, ID_STRING, (LPSTR) szString, sizeof(szString));
          GetDialogInt(hDlg, ID_POS, &iPos);

          /*
            Determine the operation to perform
          */
          operation = 0;
          if (IsDialogButtonChecked(hDlg, ID_APPEND))
            operation = LB_ADDSTRING;
          else if (IsDialogButtonChecked(hDlg, ID_INSERT))
            operation = LB_INSERTSTRING;
          else if (IsDialogButtonChecked(hDlg, ID_DELETE))
            operation = LB_DELETESTRING;

          if (operation)
          {
            SendDlgItemMessage(hDlg, ID_LISTBOX, operation, iPos,
                                      (DWORD) (char far *) szString);
            MessageBox(szString, NULL, NULL, "Completed", MB_OK | MB_ICONEXCLAMATION);
          }
          break;

        case IDCANCEL  :
          /*
             If the user pressed the QUIT button, then send a WM_QUIT
             message to all the window procs
          */
          EndDialog(hDlg, 0);
          break;

        case ID_APPEND :
        case ID_DELETE :
        case ID_INSERT :
          /*
            The user pressed a radio button. Enable this one and disable
            the others
          */
          CheckRadioButton(hDlg, ID_APPEND, ID_DELETE, wParam);
          break;

        case ID_LISTBOX :
          switch (HIWORD(lParam))
          {
          	case LBN_SELCHANGE :
              if (nMovedItem < 0)
                return FALSE;
              iSel = SendDlgItemMessage(hDlg,ID_LISTBOX,LB_GETCURSEL,0,0L);
              SendDlgItemMessage(hDlg,ID_LISTBOX,LB_DELETESTRING,nMovedItem,0L);
              SendDlgItemMessage(hDlg,ID_LISTBOX,LB_INSERTSTRING,iSel,
                                 (DWORD) (char far *) szItemText);
              nMovedItem = iSel;
              break;
          }
          return FALSE;
      }

      return TRUE;
  }

  return FALSE;
}


HWND pascal DialogCreateIndirect(hParent, row1,col1,row2,col2, szTitle,
                                 attr, fFlags, pfnDlgProc, pTemplate, nTemplate)
  HWND hParent;
  int  row1, col1, row2, col2;
  char *szTitle;
  WORD attr;
  DWORD fFlags;
  int  (pascal *pfnDlgProc)();
  DTEMPLATE *pTemplate;
  int  nTemplate;
{
  HDLG hDlg;
  HWND hCtrl;

  hDlg = DialogCreate(hParent,row1,col1,row2,col2,szTitle,attr,fFlags,pfnDlgProc,0);
  if (hDlg == NULLHWND)
    return NULLHWND;

  while (nTemplate-- > 0)
  {
    hCtrl = CreateWindow(pTemplate->szClass, pTemplate->szTitle,
                         pTemplate->dwStyle,
                         pTemplate->x,     pTemplate->y,
                         pTemplate->width, pTemplate->height,
                         0x31, pTemplate->idCtrl,
                         hDlg,              /* hParent */
                         (HMENU) NULLHWND,  /* hMenu   */
                         0,                 /* hInst   */
                         (DWORD) NULL);     /* lpCreateParams */
    if (hCtrl == NULLHWND)
      return NULLHWND;
    pTemplate++;
  }

  return (HWND) hDlg;
}


/**************************************************************************/
/*                                                                        */
/*             TIMER DEMO                                                 */
/*                                                                        */
/**************************************************************************/

#define NUMTIMERS  8
HWND hTimerWnd[NUMTIMERS];

extern long pascal TimerWndProc();
extern HMENU TimerMenuInit(HWND hWnd);


TimerDemo()
{
  int   i;
  HWND  hWnd;
  HMENU hMenu;
  char  title[16];

  for (i = 1;  i <= NUMTIMERS;  i++)
  {
    sprintf(title, "Timer %d", i);

    hWnd = hTimerWnd[i-1] =
       CreateWindow("Normal",       /* class */
                    title,          /* title */
                    WIN_HAS_BORDER | WS_CLIP, /* dwStyle */
                    ((i-1)%2) ? 40 : 20, 
                    ((i-1)/2)*5 + 3,
                    25, 4,
                    0x70,           /* attr */
                    0,              /* id */
                    hMain,          /* hParent */
                    NULLHWND,       /* hMenu */
                    0,              /* hInst */
                    0L);            /* lpParam */

    WinSetWinProc(hWnd, TimerWndProc);
    hMenu = TimerMenuInit(hWnd);
    SetMenu(hWnd, hMenu);
    SetTimer(hWnd, i, i*1000, (FARPROC) NULL);
  }

  ShowWindow(hMain, TRUE);
  SetFocus(hTimerWnd[0]);
}


HMENU TimerMenuInit(HWND hWnd)
{
  HMENU hMenu, hPop;

  /*
    Create the menu bar
  */
  hMenu = CreateMenu(hWnd);
  
  /*
    Create a pulldown
  */
  hPop = CreateMenu(hMenu);
  ChangeMenu(hPop, 0, "~Stop",        ID_STOP,        MF_APPEND);
  ChangeMenu(hPop, 0, "~Interval",    ID_INTERVAL,    MF_APPEND);
  ChangeMenu(hPop, 0, "E~xit",        ID_EXIT,        MF_APPEND);

  /*
    Attach each of the pulldowns to their corresponding menubar entries
  */
  ChangeMenu(hMenu, 0, "~Timer",   hPop, MF_POPUP | MF_APPEND);

  return hMenu;
}



long pascal TimerWndProc(hWnd, msg, wParam, lParam)
  HWND hWnd;
  WORD msg;
  WORD wParam;
  DWORD lParam;
{
  char szTime[80];
  int  hrs, min, sec;
  int  i;

  switch (msg)
  {
    case WM_TIMER :
      DosGetTime(&hrs, &min, &sec);
      sprintf(szTime, "%02d:%02d:%02d", hrs, min, sec);
      WinPutsCenter(hWnd, 0, szTime, WinGetAttr(hWnd));
/*    SoundNote(CNOTE + wParam, MIN_OCTAVE + wParam, 100);  */
      return TRUE;

    case WM_CHAR    :
      if (wParam == VK_TAB)
      {
        for (i = 1;  i <= NUMTIMERS;  i++)
          if (hTimerWnd[i-1] == hWnd)
          {
            SetFocus(hTimerWnd[ (i == NUMTIMERS) ? 0 : i ]);
            return TRUE;
          }
      }
      break;

    case WM_SETFOCUS :
      BringWindowToTop(hWnd);
      return DefWinProc(hWnd, msg, wParam, lParam);

    case WM_COMMAND :
      switch (wParam)
      {
        case ID_EXIT :
        case ID_STOP :
          for (i = 1;  i <= NUMTIMERS;  i++)
            if (hTimerWnd[i-1] == hWnd)
            {
              KillTimer(i);
              ChangeMenu(GetSubMenu(GetMenu(hWnd), 0),
                         0, "Start", ID_START, MF_CHANGE | MF_STRING);
            }

          if (wParam == ID_EXIT)
          {
            for (i = 1;  i <= NUMTIMERS;  i++)
              DestroyWindow(hTimerWnd[i-1]);
          }
          break;

        case ID_START:
          for (i = 1;  i <= NUMTIMERS;  i++)
            if (hTimerWnd[i-1] == hWnd)
            {
              SetTimer(hWnd, i, i*1000, (FARPROC) NULL);
              ChangeMenu(GetSubMenu(GetMenu(hWnd), 0),
                         0, "Stop", ID_STOP, MF_CHANGE | MF_STRING);
            }
          break;

        case ID_INTERVAL :
          NewInterval(hWnd);
          break;
      }
      return TRUE;

    default :
      return DefWinProc(hWnd, msg, wParam, lParam);
  }
}



NewInterval(hWnd)
  HWND hWnd;
{
  HDLG hDlg;
  int  i, tid;
  unsigned interval;
  extern int  pascal IntervalDlgProc();

  for (i = 1;  i <= NUMTIMERS;  i++)
    if (hTimerWnd[i-1] == hWnd)
    {
      tid = i;
      break;
    }

  hDlg = DialogCreateIndirect(NULLHWND,
                              8,26,13,51,
                              "New Interval",
                              0x31,0L,IntervalDlgProc,
                              IntervalDialogTemplate,
                              sizeof(IntervalDialogTemplate) / sizeof(DTEMPLATE));

  if ((interval = DialogBox(hDlg)) != IDCANCEL)
  {
    KillTimer(tid);
    SetTimer(hWnd, tid, interval, (FARPROC) NULL);
  }
}


int pascal IntervalDlgProc(hDlg, msg, wParam, lParam)
  HWND hDlg;
  WORD msg;
  WORD wParam;
  DWORD lParam;
{
  char szInterval[80];

  switch (msg)
  {
    case WM_INITDIALOG :
      return TRUE;

    case WM_COMMAND :
      if (wParam == IDCANCEL)
        EndDialog(hDlg, IDCANCEL);
      else if (wParam == IDOK)
      {
        GetDialogText(hDlg, ID_INTERVAL, (char far *) szInterval, 65);
        EndDialog(hDlg, atoi(szInterval));
      }
      return TRUE;

    default :
      return FALSE;
  }
}


/**************************************************************************/
/*                                                                        */
/*             MOUSE DEMO                                                 */
/*                                                                        */
/**************************************************************************/

MouseDemo()
{
  if (!GetSystemMetrics(SM_MOUSEPRESENT))
  {
    MessageBox("You must have a mouse","to run this demo.",NULL,"ERROR",MB_OK);
    return FALSE;
  }

  hMouseWnd = CreateWindow("Normal",   /* class */
                       "Mouse Coordinates", /* title */
                       WS_BORDER,      /* dwStyle */
                       30,10, 20,3,    /* x,y,width,height */
                       0x31,           /* attr */
                       1,              /* id */
                       hMain,          /* hParent */
                       NULLHWND,       /* hMenu */
                       0,              /* hInst */
                       0L);            /* lpParam */

  ShowWindow(hMain, TRUE);
  return TRUE;
}

/**************************************************************************/
/*                                                                        */
/*  SCRLDEMO.C - demonstration of the usage of scroll bars....            */
/*                                                                        */
/**************************************************************************/


PrintScrollbarValues(WORD message, WORD wParam, DWORD lParam)
{
  char *type;
  char buf[80];
  HWND hSB;
  int  minpos, maxpos, currpos;

  hSB = HIWORD(lParam);			/* HIWORD(lParam) has the scrollbar handle */
  currpos = GetScrollPos(hSB, SB_CTL);
  GetScrollRange(hSB, SB_CTL, &minpos, &maxpos);

  switch (wParam)
  {
  	case SB_LINEUP   :
      SetScrollPos(hSB, SB_CTL, max(currpos-1, minpos), TRUE);
      currpos = GetScrollPos(hSB, SB_CTL);
      type = "SB_LINEUP";
      break;

  	case SB_LINEDOWN :
      SetScrollPos(hSB, SB_CTL, min(currpos+1, maxpos), TRUE);
      currpos = GetScrollPos(hSB, SB_CTL);
      type = "SB_LINEDOWN";
      break;

  	case SB_PAGEUP   :
      SetScrollPos(hSB, SB_CTL, max(currpos-10, minpos), TRUE);
      currpos = GetScrollPos(hSB, SB_CTL);
      type = "SB_PAGEUP";
      break;

  	case SB_PAGEDOWN :
      SetScrollPos(hSB, SB_CTL, min(currpos+10, maxpos), TRUE);
      currpos = GetScrollPos(hSB, SB_CTL);
      type = "SB_PAGEDOWN";
      break;

    case SB_THUMBTRACK :
      type = "SB_THUMBTRACK";
      goto do_it;
    case SB_THUMBPOSITION :
      type = "SB_THUMBPOSITION";
      goto do_it;
    case SB_ENDSCROLL  :
      type = "SB_ENDSCROLL";
do_it:
      currpos = LOWORD(lParam);
      SetScrollPos(hSB, SB_CTL, max(min(currpos, maxpos), minpos), TRUE);
      currpos = GetScrollPos(hSB, SB_CTL);
      break;
  }

  sprintf(buf, "Message [%s]   Position [%3d]  %3d%%     ",
                       type, currpos, currpos * 100 / maxpos);
  WinEraseEOL(hMsgWnd, 0, 0, 0x31);
  WinPutsCenter(hMsgWnd, 0, buf, 0x31);
}


/**************************************************************************/
/*                                                                        */
/*  POPTEST.C - demonstration of the usage of floating popups             */
/*                                                                        */
/**************************************************************************/

#define ID_FLOAT    11

DoFloatingPopup()
{
  WORD  hRes;
  HMENU hMenu;

  hRes = OpenResourceFile("mewldemo");
  if (hRes)
  {
    hMenu = LoadPopupMenu(hRes, ID_FLOAT, hMain);
    CloseResourceFile(hRes);
    if (hMenu)
      TrackPopupMenu(hMenu,0,30,10,20,hMain,(LPRECT) NULL);
  }
}


/**************************************************************************/
/*                                                                        */
/*  COMBODEMO - demonstration of the usage of combo boxes                 */
/*                                                                        */
/**************************************************************************/


char *szColors[] =
{
  "Black", "Blue", "Green", "Cyan", "Red", "Magenta", "Yellow", "White", NULL
};


ComboDemo(DWORD dwStyle)
{
  int i;

  hCombo = CreateWindow("ComboBox",    /* class */
                       NULL,           /* title */
                       dwStyle,        /* dwStyle */
                       20,5, 16, 8,    /* x,y,width,height */
                       0x31,           /* attr */
                       ID_COMBOBOX,    /* id */
                       hMain,          /* hParent */
                       NULLHWND,       /* hMenu */
                       0,              /* hInst */
                       0L);            /* lpParam */

  SendMessage(hCombo, WM_SETREDRAW, FALSE, 0L);
  for (i = 0;  szColors[i];  i++)
    SendMessage(hCombo, CB_ADDSTRING, 0, (DWORD) (LPSTR) szColors[i]);
  SendMessage(hCombo, WM_SETREDRAW, TRUE, 0L);

  ShowWindow(hMain, TRUE);
  SetFocus(hCombo);
}


/*===========================================================================*/
/*                                                                           */
/* File    : EDITDEMO.C                                                      */
/*                                                                           */
/* Purpose : Demo of a multi-line edit field plus a new kind of button       */
/*                                                                           */
/* History :                                                                 */
/*                                                                           */
/* (C) Copyright 1989 Marc Adler/Magma Systems     All Rights Reserved       */
/*===========================================================================*/

extern long pascal NotepadWndProc();

HWND hWndNotepad, hEdit;
LPSTR pszFileToOpen = NULL;

NotePad()
{
  WORD  hRes;
  HMENU hMenu;

  hWndNotepad = CreateWindow("Normal",     /* class */
                             "Notepad",    /* title */
                             WS_BORDER | WS_CAPTION | WS_SYSMENU |
                             WS_MOVEBOX,
                             5,2, 60,20,     /* x,y,width,height */
                             SYSTEM_COLOR,   /* attr */
                             0,              /* id */
                             hMain,          /* hParent */
                             NULLHWND,       /* hMenu */
                             0,              /* hInst */
                             0L);            /* lpParam */
  WinSetWinProc(hWndNotepad, NotepadWndProc);


  hEdit = CreateWindow("Edit",         /* class */
                       "Enter text",   /* title */
                       ES_MULTILINE | ES_MARGIN,
                       7,4, 56,16,    /* x,y,width,height */
                       0x70,           /* attr */
                       ID_NOTEPAD,     /* id */
                       hWndNotepad,    /* hParent */
                       NULLHWND,       /* hMenu */
                       0,              /* hInst */
                       0L);            /* lpParam */

  if ((hRes = OpenResourceFile("mewldemo")) == 0)
  {
    MessageBox("Can't find the", "resource file", "MEWLDEMO.RES", "Fatal Error", MB_OK);
    exit(1);
  }
  hMenu = LoadMenu(hRes, ID_NOTEPAD, hWndNotepad);
  CloseResourceFile(hRes);
  SetMenu(hWndNotepad, hMenu);

  ShowWindow(hWndNotepad, TRUE);
  SetFocus(hEdit);

#if 0
  if (argc > 1)
    OpenFile(argv[1]);
#endif
}


OpenFile(char *fname)
{
  int  fd;
  char *pBuf = emalloc(4 * 1024);

  if (!fname)
    return FALSE;

  if (pBuf == NULL)
  {
    MessageBox("Cannot alloc memory", "for reading", NULL, "Error", MB_OK);
    return TRUE;
  }

  if ((fd = open(fname, O_RDONLY)) < 0)
  {
    free(pBuf);
    MessageBox("Cannot open file", fname, "for reading", "Error", MB_OK);
    return TRUE;
  }
  else
  {
    int len = read(fd, pBuf, (4 * 1024) - 1);
    pBuf[len] = '\0';
    close(fd);
    SetWindowText(hEdit, pBuf);
    free(pBuf);
  }
  return TRUE;
}


long pascal NotepadWndProc(hWnd, message, wParam, lParam)
  HWND hWnd;
  WORD message;
  WORD wParam;
  DWORD lParam;
{
  char *type;
  char buf[80];
  HWND hSB;
  int  minpos, maxpos, currpos;
  char *pHandle;

  switch (message)
  {
    case WM_COMMAND    :
      switch (wParam)
      {
        case ID_OPEN:
          if (DlgOpenFile(NULLHWND, "*.txt", buf))
          {
            OpenFile(buf);
          }
          break;
        case ID_SAVE:
          return BadCommand();
        case ID_SAVEAS:
          return BadCommand();

        case ID_EXIT:
          PostQuitMessage(0);
          break;


        case ID_CUT :
          SendMessage(hEdit, WM_CUT, 0, 0L);
          break;
        case ID_CLEAR:
          SendMessage(hEdit, WM_CLEAR, 0, 0L);
          break;
        case ID_COPY:
          SendMessage(hEdit, WM_COPY, 0, 0L);
          break;
        case ID_PASTE:
          SendMessage(hEdit, WM_PASTE, 0, 0L);
          break;

        case ID_GETLEN :
          sprintf(buf, "%d", SendMessage(hEdit, WM_GETTEXTLENGTH, 0, 0L));
          MessageBox("There are", buf, "characters", "Text Length", MB_OK);
          break;
        case ID_GETLINES:
          sprintf(buf, "%d", SendMessage(hEdit, EM_GETLINECOUNT, 0, 0L));
          MessageBox("There are", buf, "lines", "# of Lines", MB_OK);
          break;
        case ID_GETHANDLE:
          SendMessage(hEdit, EM_GETHANDLE, 0, (DWORD) (char *far *) &pHandle);
          sprintf(buf, "[%p]", pHandle);
          MessageBox("The edit handle is", buf, NULL, "Get Handle", MB_OK);
          break;
      }
      break;


    case WM_SYSCOMMAND :
      switch (wParam)
      {
        case SC_CLOSE :
          PostQuitMessage(0);
          break;
      }
      break;

    default :
      /* Call the default window procedure for the main window */
      return DefWinProc(hWnd, message, wParam, lParam);
  }
}


BadCommand()
{
  MessageBox("This command has", "not been implemented", "yet!", "Error", MB_OK);
  return TRUE;
}

extern int pascal WinExec(char *szCmd, BOOL bSwap);

DOSEscape()
{
  MessageBox("Execing with swapping", NULL, NULL, "Swap", MB_OK);
  WinExec(NULL, TRUE);

  MessageBox("Execing without swapping", NULL, NULL, "Swap", MB_OK);
  WinExec(NULL, FALSE);
}
